shdel__debug("loaded preferences.js");

function shdel__saveOptions() {
  shdel__debug("shdel__saveOptions");
  try {
    var prefs = shdel__getMyPrefs();
    
    if (document.getElementById("shdel__gui_disable").selected) {
      prefs.setCharPref("key_state", "disable");
      shdel__debug("set 2 disable");
    }
    else if (document.getElementById("shdel__gui_delete").selected) {
      prefs.setCharPref("key_state", "delete");
      shdel__debug("set 2 delete");
    }
    else if (document.getElementById("shdel__gui_shdelete").selected) {
      prefs.setCharPref("key_state", "shift-delete");
      shdel__debug("set 2 sh-delete");	    
    }
    else if (document.getElementById("shdel__gui_smart").selected) {
      prefs.setCharPref("key_state", "smart");
      shdel__debug("set 2 smart");	    
    }

    var state = shdel__getCharPref(prefs, 'key_state', "disable");
    shdel__debug("state=" + state);

    var msgNum = document.getElementById("shdel__gui_msgnum").value;
    var intMsgNum = parseInt(msgNum, 10);
    if (!isNaN(intMsgNum)) {
      shdel__debug("msgNum=" + msgNum);
      prefs.setIntPref("smart_silent_del", msgNum);
    } else {
      alert("Not a number specified, not changing msg amount");
    }
  } catch(e) {
    shdel__debug("E!:" + e + "\n");
  }
  shdel__debug("shdel__saveOptions DONE");
}

function shdel__initializeOptions() {
  shdel__debug("shdel__initOpt");
  try {
    var prefs = shdel__getMyPrefs();
    var state = shdel__getCharPref(prefs, "key_state", "disable");
    var smartMsgNum = shdel__getIntPref(prefs, "smart_silent_del", 1);
    
    switch(state) {
    case "disable":
      document.getElementById("shdel__gui_disable").setAttribute("selected", true);
      break;
      
    case "shift-delete":
      document.getElementById("shdel__gui_shdelete").setAttribute("selected", true);
      break;
      
    case "delete":
      document.getElementById("shdel__gui_delete").setAttribute("selected", true);
      break;
      
    case "smart":
      document.getElementById("shdel__gui_smart").setAttribute("selected", true);
      break;
    }
    
    shdel__debug("shdel__initOpt: state=" + state);
    shdel__debug("shdel__initOpt: smartMsgNum=" + smartMsgNum);
    
    var msgnum_gui = document.getElementById("shdel__gui_msgnum");
    if (state != "smart") 
      msgnum_gui.setAttribute("disabled", true);
    msgnum_gui.setAttribute("value", smartMsgNum);
  } 
  catch(e) {
    shdel__debug("initE!:" + e + "\n");
  }

  shdel__debug("shdel__initOpt: DONE");
}


function shdel__pref_gui_enab_smart() 
{
  shdel__debug("shdel__pref_gui_enab_smart()");
  
  try {
    shdel__debug("enab");	    
    shdel__pref_gui_setstate_smart(false);
  } catch (e) { 
    shdel__debug("shdel__pref_gui_enab_smart::E:" + e + "\n");
  }

  shdel__debug("shdel__pref_gui_enab_smart() DONE");
}

function shdel__pref_gui_disab_smart() 
{
  shdel__debug("shdel__pref_gui_disab_smart()");

  try {
    shdel__debug("disab");
    shdel__pref_gui_setstate_smart(true);
  } catch (e) { 
    shdel__debug("shdel__pref_gui_disab_smart::E:" + e + "\n");
  }

  shdel__debug("shdel__pref_gui_disab_smart() DONE");
}

function shdel__pref_gui_setstate_smart(state) 
{
  shdel__debug("shdel__pref_gui_setstate_smart()");

  try {
    var widgets = new Array();
    widgets[0] = "shdel__gui_msgnum";
    shdel__debug("widgets length=" + widgets.length);
    
    for (var i = 0; i < widgets.length; i++) {
      shdel__debug("w=" + widgets[i]);
      if (state == false)
	document.getElementById(widgets[i]).removeAttribute('disabled');
      else
	document.getElementById(widgets[i]).setAttribute("disabled", state);
    }
  } catch (e) { 
    shdel__debug("shdel__pref_gui_setstate_smart::E:" + e + "\n");
  }

  shdel__debug("shdel__pref_gui_setstate_smart() DONE");
}

shdel__debug("END loaded preferensec.js");
